UNIT GAnsi;


INTERFACE


USES GUtils, Crt;


CONST
  BufferLength = 250;

TYPE
  String20     = STRING[20];

VAR
  DelayNum     : Word;
  Quiet        : Boolean;


PROCEDURE ANSIWrite(Ch:Char);
PROCEDURE Play(MusicStr:STRING);
PROCEDURE PlaySound(Freq:Word; Dura:Real; Cycles:Word; Dly:LongInt; Vari:Real);
PROCEDURE InitAnsiWrite;

FUNCTION  ANSIClrScr                   :String20;
FUNCTION  ANSIClrEol                   :String20;
FUNCTION  ANSIGotoXY   (X, Y  :Word)   :String20;
FUNCTION  ANSIUp       (Lines :Word)   :String20;
FUNCTION  ANSIDown     (Lines :Word)   :String20;
FUNCTION  ANSIRight    (Cols  :Word)   :String20;
FUNCTION  ANSILeft     (Cols  :Word)   :String20;
FUNCTION  ANSIColor    (Fg, Bg:Integer):String20;



IMPLEMENTATION


VAR
  ANSI_St   : STRING;
  ANSI_SCPL : Integer;
  ANSI_SCPC : Integer;
  ANSI_FG   : Integer;
  ANSI_BG   : Integer;
  ANSI_C,
  ANSI_I,
  ANSI_B,
  ANSI_R    : Boolean;
  Music     : Boolean;

  P,X,Y     : Integer;



{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
{- - - - - - - - - - - - - - - - - ANSI Write  - - - - - - - - - - - - - - -}
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
PROCEDURE ANSIWrite(Ch:Char);

  PROCEDURE Tabulate;
  VAR X:Integer;
  BEGIN
    X := WhereX;
    IF X < 80 THEN REPEAT
                     Inc(X);
                   UNTIL (X MOD 8)=0;
    IF X = 80 THEN X := 1;
    GotoXY(X,WhereY);
    IF X = 1 THEN WriteLN;
  END;

  PROCEDURE BackSpace;
  VAR X:Integer;
  BEGIN
    IF WhereX > 1
      THEN Write(^H,' ',^H)
      ELSE IF WhereY>1
             THEN BEGIN
                    GotoXY(80,WhereY-1);
                    Write(' ');
                    GotoXY(80,WhereY-1);
                  END;
  END;

  PROCEDURE TTY(Ch:Char);
  VAR X:Integer;
  BEGIN
    IF ANSI_C THEN
    BEGIN
      IF ANSI_I THEN ANSI_FG := ANSI_FG OR 8;
      IF ANSI_B THEN ANSI_FG := ANSI_FG OR 16;
      IF ANSI_R THEN
      BEGIN
        X := ANSI_FG;
        ANSI_FG := ANSI_BG;
        ANSI_BG := X;
      END;
      ANSI_C := False;
    END;
    TextColor(ANSI_FG);
    TextBackground(ANSI_BG);
    CASE Ch OF
      ^G: BEGIN
            IF NOT Quiet THEN
            BEGIN
              GUtils.Sound(500);
              GUtils.Delay(80);
              GUtils.NoSound;
            END;
          END;
      ^H: Backspace;
      ^I: Tabulate;
      ^J: BEGIN
            TextBackground(0);
            Write(^J);
          END;
      ^L: BEGIN
            TextBackground(0);
            ClrScr;
          END;
      ^M: BEGIN
            TextBackground(0);
            Write(^M);
          END;
      ELSE Write(Ch);
    END;
    IF DelayNum <> 0 THEN GUtils.Delay(DelayNum);
  END;

  PROCEDURE ANSIWrite(S:STRING);
  VAR X:Integer;
  BEGIN
    FOR X := 1 TO Length(S) DO TTY(S[X]);
  END;

  FUNCTION Param:Integer;   {returns -1 if no more parameters}
  VAR S:STRING;
      X,XX:Integer;
      B:Boolean;
  BEGIN
    B := False;
    FOR X := 3 TO Length(ANSI_St) DO IF ANSI_St[X] IN ['0'..'9'] THEN B:=True;
    IF NOT B
      THEN Param := -1
      ELSE BEGIN
             S := '';
             X := 3;
             if ANSI_St[3] = ';' then
             BEGIN
               Param := 0;
               Delete(ANSI_St,3,1);
               Exit;
             END;
             REPEAT
               S := S+ANSI_St[x];
               X := X+1;
             UNTIL (NOT (ANSI_St[x] IN ['0'..'9'])) OR (Length(S)>2) OR (x>Length(ANSI_St));
             Delete(ANSI_St,3,Length(S));
             IF ANSI_St[3]=';' THEN Delete(ANSI_St,3,1);
             Val(S,x,XX);
             Param := X;
           END;
  END; {Param}

BEGIN
  IF Music THEN
  BEGIN
    IF (Ch = #14) OR (Length(ANSI_St) > 80)
      THEN BEGIN
             ANSI_St := 'M'+ANSI_St;
             IF NOT Quiet THEN Play(ANSI_St);
             ANSI_St := '';
             Music := False;
           END
      ELSE ANSI_St := ANSI_St + Ch;
    Exit;
  END;
  IF (Ch <> #27) AND (ANSI_St = '') THEN
  BEGIN
    TTY(Ch);
    Exit;
  END;

  IF Ch = #27 THEN
  BEGIN
    IF ANSI_St <> ''
      THEN BEGIN
             ANSIWrite(ANSI_St+#27);
             ANSI_St := '';
           END
      ELSE ANSI_St := #27;
    Exit;
  END;
  IF ANSI_St = #27 THEN
  BEGIN
    IF Ch = '['
      THEN ANSI_St := #27+'['
      ELSE BEGIN
             ANSIWrite(ANSI_St+Ch);
             ANSI_St:='';
           END;
    Exit;
  END;
  IF (Ch = '[') AND (ANSI_St <> '') THEN
  BEGIN
    ANSIWrite(ANSI_St+'[');
    ANSI_St := '';
    Exit;
  END;
  IF NOT (Ch IN ['0'..'9',';','A'..'D','f','H','J','K','M','m','s','u']) THEN
  BEGIN
    ANSIWrite(ANSI_St+Ch);
    ANSI_St := '';
    Exit;
  END;

  IF Ch IN ['A'..'D','f','H','J','K','M','m','s','u'] THEN
  BEGIN
    CASE Ch OF
    'A': BEGIN
           P := Param;
           IF P = -1 THEN P := 1;
           IF WhereY-P < 1
             THEN GotoXY(WhereX,1)
             ELSE GotoXY(WhereX,WhereY-P);
         END;
    'B': BEGIN
           P := Param;
           IF P = -1 THEN P := 1;
           IF WhereY+P > MaxY
             THEN GotoXY(WhereX,MaxY)
             ELSE GotoXY(WhereX,WhereY+P);
         END;
    'C': BEGIN
           P := Param;
           IF P = -1 THEN P := 1;
           IF WhereX+P > 80
             THEN GotoXY(80,WhereY)
             ELSE GotoXY(WhereX+P,WhereY);
         END;
    'D': BEGIN
           P := Param;
           IF P = -1 THEN P := 1;
           IF WhereX-P < 1
             THEN GotoXY(1,WhereY)
             ELSE GotoXY(WhereX-P,WhereY);
         END;
'H','f': BEGIN
           Y := Param;
           X := Param;
           IF Y < 1 THEN Y := 1;
           IF X < 1 THEN X := 1;
           IF (X>80) OR (X<1) OR (Y>MaxY) OR (Y<1) THEN
           BEGIN
             ANSI_St:='';
             Exit;
           END;
           GotoXY(X,Y);
         END;
    'J': BEGIN
           P := Param;
           IF P=2 THEN
           BEGIN
             TextBackground(0);
             ClrScr;
           END;
           IF P = 0 THEN
           BEGIN
             X := WhereX;
             Y := WhereY;
             Window(1,Y,80,MaxY);
             TextBackground(0);
             ClrScr;
             Window(1,1,80,MaxY);
             GotoXY(x,Y);
           END;
           IF P = 1 THEN
           BEGIN
             X := WhereX;
             Y := WhereY;
             Window(1,1,80,WhereY);
             TextBackground(0);
             ClrScr;
             Window(1,1,80,MaxY);
             GotoXY(x,Y);
           END;
         END;
    'K': ClrEol;
    'M': Music := True;
    'm': BEGIN
           IF ANSI_St = #27+'[' THEN
           BEGIN
             ANSI_FG:=7;
             ANSI_BG:=0;
             ANSI_I:=False;
             ANSI_B:=False;
             ANSI_R:=False;
           END;
           REPEAT
             P := Param;
             CASE P OF
               -1:;
                0: BEGIN
                     ANSI_FG:=7;
                     ANSI_BG:=0;
                     ANSI_I:=False;
                     ANSI_R:=False;
                     ANSI_B:=False;
                   end;
                1: ANSI_I:=True;
                5: ANSI_B:=True;
                7: ANSI_R:=True;
               30: ANSI_FG:=0;
               31: ANSI_FG:=4;
               32: ANSI_FG:=2;
               33: ANSI_FG:=6;
               34: ANSI_FG:=1;
               35: ANSI_FG:=5;
               36: ANSI_FG:=3;
               37: ANSI_FG:=7;
               40: ANSI_BG:=0;
               41: ANSI_BG:=4;
               42: ANSI_BG:=2;
               43: ANSI_BG:=6;
               44: ANSI_BG:=1;
               45: ANSI_BG:=5;
               46: ANSI_BG:=3;
               47: ANSI_BG:=7;
             END;
             IF ((P>=30) AND (P<=47)) OR (P=1) OR (P=5) OR (P=7) THEN ANSI_C:=True;
           UNTIL P=-1;
         END;
    's': BEGIN
           ANSI_SCPL := WhereY;
           ANSI_SCPC := WhereX;
         END;
    'u': BEGIN
           IF ANSI_SCPL > -1 THEN GotoXY(ANSI_SCPC,ANSI_SCPL);
           ANSI_SCPL := -1;
           ANSI_SCPC := -1;
         END;
    END;
    ANSI_St:='';
    Exit;
  END;
  IF Ch IN ['0'..'9',';'] THEN ANSI_St := ANSI_St+Ch;
  IF Length(ANSI_St) > BufferLength THEN
  BEGIN
    ANSIWrite(ANSI_St);
    ANSI_St:='';
    Exit;
  END;
END;




{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
{- - - - - - - - - - - - - - - - - ANSI Play - - - - - - - - - - - - - - - -}
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
VAR
  RandomFreq:Boolean;

 PROCEDURE PlaySound(Freq:Word; Dura:Real; Cycles:Word; Dly:LongInt; Vari:Real);
 VAR Counter:Integer; R:LongInt;
 BEGIN
   IF RandomFreq THEN Randomize;
   IF Cycles = 0 THEN Inc(Cycles);
   FOR Counter := 0 TO Pred(Cycles) DO
   BEGIN
     Sound(Round(Freq));
     IF Dura < 0
       THEN Wait(Round(Dura))
       ELSE Delay(Round(Dura*50));
     IF RandomFreq THEN Freq := Random(8000)+37;
     IF Vari <> 0 THEN Freq := Freq + Round(Vari);
     IF (Freq > $7FFF) OR
        (Freq < Vari) THEN
        BEGIN
          IF Vari < 0
            THEN Vari := Vari - (Vari*2)
            ELSE Vari := Vari + (Vari*2);
          Freq := Freq + Round(Vari);
        END;
     IF Dly <> 0 THEN BEGIN
                        NoSound;
                        R := Dly;
                        ClearKBuffer;
                        REPEAT
                          ASM
                               MOV CX, 1000
                          @A1: NOP
                               LOOP @A1
                          END;
                          Dec(R);
                        UNTIL KeyPressed OR (R = 0);
                        IF KeyPressed THEN Exit;
                      END;
   END;
   NoSound;
 END;

 PROCEDURE PlaySoundStr(SoundStr:STRING);
 VAR Freq:Real; Dura:Real; Cycles:Word; Dly:LongInt; Vari:Real; I:Byte; A:STRING[30];
 BEGIN
   RandomFreq := False;
   Freq:=0; Dura:=0; Cycles:=0; Dly:=0; Vari:=0;

   { Strip leading and trailing chars }
   WHILE NOT IsDigit(SoundStr[1]) OR
             (Length(SoundStr)=0) DO Delete(SoundStr,1,1);
{   WHILE NOT IsDigit(SoundStr[Length(SoundStr)]) OR
             (Length(SoundStr)=0) DO Delete(SoundStr,Length(SoundStr),1);}

   I := 2;
   WHILE Length(SoundStr) <> I DO
   BEGIN
     IF (SoundStr[I-1] = ';') AND
        (SoundStr[I]   = ';') THEN Insert('0',SoundStr,I);
     Inc(I);
   END;
   SoundStr := ReplaceChar(SoundStr,';',' ');

   CASE WordCnt(SoundStr) OF
     1: Dly := StrToInt(ExtractWords(1,1,SoundStr));
     2: BEGIN
          Freq   := StrToReal(ExtractWords(1,1,SoundStr));
          Dura   := StrToReal(ExtractWords(2,1,SoundStr));
        END;
     3: BEGIN
          Freq   := StrToReal(ExtractWords(1,1,SoundStr));
          Dura   := StrToReal(ExtractWords(2,1,SoundStr));
          Cycles := StrToInt (ExtractWords(3,1,SoundStr));
        END;
     4: BEGIN
          Freq   := StrToReal(ExtractWords(1,1,SoundStr));
          Dura   := StrToReal(ExtractWords(2,1,SoundStr));
          Cycles := StrToInt (ExtractWords(3,1,SoundStr));
          Dly    := StrToInt (ExtractWords(4,1,SoundStr));
        END;
     ELSE
        BEGIN
          Freq   := StrToReal(ExtractWords(1,1,SoundStr));
          Dura   := StrToReal(ExtractWords(2,1,SoundStr));
          Cycles := StrToInt (ExtractWords(3,1,SoundStr));
          Dly    := StrToInt (ExtractWords(4,1,SoundStr));
          A := ExtractWords(5,1,SoundStr);
          IF A = '*'
            THEN RandomFreq := True
            ELSE Vari   := StrToReal(A);
        END;
   END;
   PlaySound(Round(Freq),Dura,Cycles,Dly,Vari);
 END;

PROCEDURE Play(MusicStr:STRING);
CONST
  NoteOctave   : Integer = 4;     { current octave for note            }
  NoteFraction : Real    = 0.875; { fraction of duration given to note }
  NoteDuration : Integer = 0;     { duration of note     ^^semi-legato }
  NoteLength   : Real    = 0.25;  { length of note }
  NoteQuarter  : Real    = 500.0; { moderato pace (principal beat)     }

  QuarterNote  : Real    = 0.25;
  Digits       : SET OF '0'..'9' = ['0'..'9'];
  NoteOffset   : ARRAY['A'..'G'] OF Integer = (9,11,0,2,4,5,7);
  NoteFreqs    : ARRAY[0..84] OF Integer =
{     C    C#   D   D#    E    F   F#    G   G#    A   A#    B }
(0,  65,  69,  73,  78,  82,  87,  92,  98, 104, 110, 116, 123,
    131, 139, 147, 156, 165, 175, 185, 196, 208, 220, 233, 247,
    262, 278, 294, 312, 330, 350, 370, 392, 416, 440, 466, 494,
    524, 556, 588, 624, 660, 700, 740, 784, 832, 880, 932, 988,
   1048,1112,1176,1248,1320,1400,1480,1568,1664,1760,1864,1976,
   2096,2224,2352,2496,2640,2800,2960,3136,3328,3520,3728,3952,
   4192,4448,4704,4992,5280,5600,5920,6272,6656,7040,7456,7904);

VAR
   PlayFreq     : Integer;        { Frequency of note to be played }
   PlayDuration : Integer;        { Duration to sound note }
   RestDuration : Integer;        { Duration of rest after a note }
   Index        : Integer;        { offset in music string }
   Current      : Char;           { current character in music string }
                                  { note frequencies }

   Freq         : ARRAY[0..6,0..11] OF Integer ABSOLUTE NoteFreqs;
   Note         : Integer;
   Xn           : Real;
   K            : Integer;

  FUNCTION GetNumber: Integer;
  VAR N:Integer;
  BEGIN
    N := 0;
    WHILE (MusicStr[Index] IN Digits) DO
    BEGIN
      N := N*10+Ord(MusicStr[Index])-Ord('0');
      Inc(Index)
    END;
    Dec(Index);
    GetNumber := N;
  END;

  PROCEDURE PlayNote;
  BEGIN
    Sound(PlayFreq);
    Delay(PlayDuration);
    NoSound;
    Delay(RestDuration);
  END;

BEGIN
  IF Pos(';',MusicStr) <> 0 THEN
  BEGIN
    PlaySoundStr(MusicStr);
    Exit;
  END;
  MusicStr := AdjCase(Upper,MusicStr+' ');
  Index    := 1;
  WHILE (Index < Length(MusicStr)) DO
  BEGIN
    Current := MusicStr[Index];
    CASE Current OF
  'A'..'G' : BEGIN { a note }
               Note         := NoteOffset[Current];
               PlayFreq     := Freq[NoteOctave,Note];
               XN           := NoteQuarter * (NoteLength / QuarterNote);
               PlayDuration := Trunc(XN * NoteFraction);
               RestDuration := Trunc(XN * (1.0 - NoteFraction));
               IF MusicStr[Index+1] IN ['#','+','-'] THEN
               BEGIN
                 Inc(Index);
                 CASE MusicStr[Index] OF
                   '-'     : PlayFreq := Freq[NoteOctave, Pred(Note)];
                   '#','+' : PlayFreq := Freq[NoteOctave, Succ(Note)];
                 END;
               END;
               IF (MusicStr[Index+1] IN Digits) THEN
               BEGIN
                 Inc(Index);
                 Note := GetNumber;
                 IF (Note <  1) THEN Note := 1 ELSE IF (Note > 64) THEN Note := 64;
                 Xn   := (1.0 / Note) / QuarterNote;
                 PlayDuration := Trunc(NoteFraction * Notequarter * Xn);
                 RestDuration := Trunc((1.0 - NoteFraction) * Xn * NoteQuarter);
               END;
               {Check for dotting}
               IF MusicStr[Index+1] = '.' THEN
               BEGIN
                 Xn := 1.0;
                 WHILE(MusicStr[Index+1] = '.') do
                 BEGIN
                   Xn := Xn * 1.5;
                   Inc(Index);
                 END;
                 PlayDuration := Trunc(PlayDuration * Xn);
               END;
               PlayNote;
             END;
       'M' : BEGIN
               Inc(Index);
               Current := MusicStr[Index];
               CASE Current OF
                 'F' : ;                      {Not supported yet}
                 'B' : ;                      {Not supported yet}
                 'N' : NoteFraction := 0.875; {Normal}
                 'L' : NoteFraction := 1.000; {Legato}
                 'S' : NoteFraction := 0.750; {Staccato}
               END;
             END;
       'O' : BEGIN {Set octave}
               Inc(Index);
               Note := Ord(MusicStr[Index]) - Ord('0');
               IF (Note < 0) OR (Note > 6) THEN Note := 4;
               NoteOctave := Note;
             END;
       '<' : IF NoteOctave > 0 THEN Dec(NoteOctave);
       '>' : IF NoteOctave < 6 THEN Inc(NoteOctave);
       'N' : BEGIN
               Inc(Index);
               Note := GetNumber;
               IF (Note > 0) AND (Note <= 84)
                 THEN BEGIN
                        PlayFreq     := NoteFreqs[Note];
                        Xn           := NoteQuarter * (NoteLength / QuarterNote);
                        PlayDuration := Trunc(Xn * NoteFraction);
                        RestDuration := Trunc(Xn * (1.0 - NoteFraction));
                      END
                 ELSE IF (Note = 0) THEN
                      BEGIN
                        PlayFreq     := 0;
                        PlayDuration := 0;
                        RestDuration := Trunc(NoteFraction * NoteQuarter * (NoteLength / QuarterNote));
                      END;
               PlayNote;
             END;
       'L' : BEGIN
               Inc(Index);
               Note := GetNumber;
               IF Note > 0 THEN NoteLength := 1.0 / Note;
             END;
       'T' : BEGIN {# Of Quarter Notes In A Minute}
               Inc(Index);
               Note := GetNumber;
               IF Note < 1 THEN Note := 1;
               NoteQuarter := (1092.0 / 18.2 / Note) * 1000.0;
             END;
       'P' : BEGIN {Pause}
               Inc(Index);
               Note := GetNumber;
               IF (Note <  1) THEN Note := 1 ELSE IF (Note > 64) THEN Note := 64;
               PlayFreq := 0;
               PlayDuration := 0;
               RestDuration := Trunc(((1.0 / Note) / QuarterNote) * NoteQuarter);
               PlayNote;
             END;
    END; {Case}
    Inc(Index);
  END;
  NoSound;
END;




{---------------------------------------------------------------------------}
CONST
   ColorArray:ARRAY[0..7] OF Integer = (0,4,2,6,1,5,3,7);


FUNCTION ANSIClrScr:String20;
BEGIN
  ANSIClrScr := #27+'[2J';
END;

FUNCTION ANSIClrEol:String20;
BEGIN
  ANSIClrEol := #27+'[K';
END;

FUNCTION ANSIGotoXY(X, Y:Word):String20;
VAR XStr, YStr:String20;
BEGIN
  Str(X,XStr);
  Str(Y,YStr);
  ANSIGotoXY := #27+'['+YStr+';'+XStr+'H';
END;


FUNCTION ANSIUp(Lines:Word):String20;
VAR LinesStr:String20;
BEGIN
   Str(Lines,LinesStr);
   ANSIUp := #27+'['+LinesStr+'A';
END;


FUNCTION ANSIDown(Lines:Word):String20;
VAR LinesStr: String20;
BEGIN
  Str(Lines,LinesStr);
  ANSIDown := #27+'['+LinesStr+'B';
END;


FUNCTION ANSIRight(Cols:Word):String20;
VAR ColsStr: String20;
BEGIN
  Str(Cols,ColsStr);
  ANSIRight := #27+'['+ColsStr+'C';
END;


FUNCTION ANSILeft(Cols:Word):String20;
VAR ColsStr: String20;
BEGIN
  Str(Cols,ColsStr);
  ANSILeft := #27+'['+ColsStr+'D';
END;


FUNCTION ANSIColor(Fg, Bg:integer):String20;
VAR FgStr, BgStr, Temp:String20;
BEGIN
  Str(ColorArray[Fg MOD 8] + 30, FgStr);
  Str(ColorArray[Bg MOD 8] + 40, BgStr);
  Temp := #27+'[';
  IF Bg > 7
    THEN Temp := Temp+'5;'
    ELSE Temp := Temp+'0;';
  IF Fg > 7
    THEN Temp := Temp+'1;'
    ELSE Temp := Temp+'2;';
  ANSIColor := Temp+FgStr+';'+BgStr+'m';
END;
{---------------------------------------------------------------------------}


PROCEDURE InitAnsiWrite;
BEGIN
  ANSI_St   := '';
  ANSI_SCPL := -1;
  ANSI_SCPC := -1;
  ANSI_FG   := 7;
  ANSI_BG   := 0;
  ANSI_C    := False;
  ANSI_I    := False;
  ANSI_B    := False;
  ANSI_R    := False;
  Music     := False;
  DelayNum  := 0;
  Quiet     := False;
END;



BEGIN
  InitAnsiWrite;
  CheckBreak:= False;
END.